#include "stdafx.hpp"

#include "FileInfo.hpp"

CFileInfo::CFileInfo( const WIN32_FIND_DATA& v_finddata, bool v_modified, bool v_exists )
	//: name_ ( v_finddata.cFileName )
	: writetime_( v_finddata.ftLastWriteTime )
	, size_( v_finddata.nFileSizeLow )
	, bExist_( v_exists )
	, detectModified_( v_modified )
	, tickcount_( 0 )
	//, nExecCount_( 0 )
	, deletePending_( false )
	, deleteBeginTickCount_( 0 )
{
}

CFileInfo::CFileInfo( const CFileInfo& v_other )
	//: name_( v_other.name_ )
	: writetime_( v_other.writetime_ )
	, bExist_( v_other.bExist_ )
	, detectModified_( v_other.detectModified_ )
	, tickcount_( v_other.tickcount_ )
	, size_( v_other.size_ )
	//, nExecCount_( v_other.nExecCount_ )
	, deletePending_( v_other.deletePending_ )
	, deleteBeginTickCount_( v_other.deleteBeginTickCount_ )
{
}

CFileInfo& CFileInfo::operator=( const CFileInfo& v_other )
{
	if( this == &v_other ) {
		return *this;
	}

	//name_ = v_other.name_;
	writetime_ = v_other.writetime_;
	bExist_ = v_other.bExist_;
	detectModified_ = v_other.detectModified_;
	tickcount_ = v_other.tickcount_;
	size_ = v_other.size_;
	//nExecCount_ = v_other.nExecCount_;
	deletePending_ = v_other.deletePending_;
	deleteBeginTickCount_ = v_other.deleteBeginTickCount_;

	return *this;
}

CFileInfo::~CFileInfo()
{
}

void CFileInfo::update( const WIN32_FIND_DATA& v_finddata )
{
	//name_  = v_finddata.cFileName;
	writetime_ = v_finddata.ftLastWriteTime;
	size_ = v_finddata.nFileSizeLow;
}

void CFileInfo::setExist( bool v_exist )
{
	bExist_ = v_exist;
}

void CFileInfo::setDeletePending( bool v_deletePending ) 
{
	deletePending_ = v_deletePending;
}

void CFileInfo::setDeleteBeginTickCount( DWORD v_tickcount )
{
	deleteBeginTickCount_ = v_tickcount;
}

void CFileInfo::setDetectModified( bool v_detectModified )
{
	detectModified_ = v_detectModified;
}

//void CFileInfo::setFileName( const tstring& v_fileName )
//{
//	name_ = v_fileName;
//}

void CFileInfo::setLastModified( const FILETIME& v_filetime )
{
	writetime_ = v_filetime;
}

void CFileInfo::setCountdownTickCount( DWORD v_tickcount )
{
	tickcount_ = v_tickcount;
}

void CFileInfo::setSize( DWORD v_size )
{
	size_ = v_size;
}

//void CFileInfo::incrementExecuteCount()
//{
//	nExecCount_++;
//}
