#ifndef INCLUDE_H_CWatchThread
#define INCLUDE_H_CWatchThread

#include "SettingInfo.hpp"

#include "tstring.hpp"
#include <map>
#include <list>

#include "FileInfo.hpp"

#include "ActionInvoker.hpp"
#include "PatternMatch.hpp"

class CWatchThread
{
private:
	CWatchThread( const CWatchThread& ); //<! Ȃ
	operator=( const CWatchThread& ); //<! Ȃ

public:
	CWatchThread( const CSettingInfo& v_settingInfo );

	virtual ~CWatchThread();

	const CSettingInfo& getSettingInfo() const;

	void Start();

	void Stop();

	void StopNoWait();

	bool isRunning() const;

private:

	void run();

	void prepareDeleteEntries();

	void sweepDeletedEntries();

	void EnumFile(const bool v_enableEvent );

	bool EnumFileRecursive( const tstring& v_baseDir, const int v_depth, const bool v_enableEvent );

	static bool getFileSize( const tstring& v_path, DWORD* v_pSizeLow, DWORD* v_pSizeHi = NULL );

	static unsigned __stdcall CWatchThread::FWatchThread( void* pParam );

private:
	typedef std::map<tstring, CFileInfo > CFileInfoMap;

	CFileInfoMap fileInfoMap_;

	typedef std::list<tstring> FileNameList;

	FileNameList deletePendingList_;

	PatternMatchCollection nameFilter_;

	ActionInvokerPtr pActionInvoker_;

	const FileTimeComparator fileTimeComparator_;

	CSettingInfo settingInfo_;

	HANDLE hStopEvent_;

	HANDLE hThread_;

	DWORD nThreadID_;

};


#endif
